{ 021109e2b.pas                                                             }
{ 2002-11-09 programmeerimisvistluse edasijudnute 2. lesande lahendus    }
{    AVALDIS                                                                }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'AVALDIS.SIS';
   valf = 'AVALDIS.VAL';
   num = ['0'..'9'];
   teh = ['+', '-', '*', '/'];

{ "loeb" snest s alates positsioonist i he mrgita tisarvu }
{ lesande tekstis polnud eldud, kas arv vib alata vi lppeda komaga }
{ see funktsioon niisuguseid arve ei luba; selliseid testides ei ole ka }
function loe_arv(var s : string; var i : integer) : boolean;
begin
   loe_arv := (s[i] in num);         { arvus peab olema vhemalt ks number }
   { kik jrgnevad numbrid on ka samas arvus }
   while s[i] in num do begin
      i := i + 1;
   end;
   { koma ja sellele jrgnevad numbrid on ka samas arvus }
   if s[i] = ',' then begin
      i := i + 1;
      loe_arv := (s[i] in num);          { prast koma peab ka number olema }
      { kik jrgnevad numbrid on ka samas arvus }
      while s[i] in num do begin
         i := i + 1;
      end;
   end;
end;

{ "loeb" snest s alates positsioonist i he avaldise }
function loe_avaldis(var s : string; var i : integer) : boolean;
var l : boolean;
begin
   l := false;
   if s[i] in num then begin                      { kui algab numbriga, ... }
      l := loe_arv(s, i);                              { ... peab olema arv }
   end else begin                                   { muidu peavad olema... }
      if s[i] = '(' then begin                        { ... algav sulg, ... }
         i := i + 1;
         if loe_avaldis(s, i) then begin                 { ... avaldis, ... }
            if s[i] = ')' then begin                  { ... ja lpetav sulg }
               i := i + 1;
               l := true;                                  { siis on korras }
            end;
         end;
      end;
   end;
   if l then begin                                   { kui algus oli korras }
      if s[i] in teh then begin                { kui nd on tehtemrk, ... }
         i := i + 1;
         loe_avaldis := loe_avaldis(s, i);      { ... peab jrgnema avaldis }
      end else begin
         loe_avaldis := true;                             { muidu on korras }
      end;
   end else begin
      loe_avaldis := false;
   end;
end;

{ kontrollib, kas snes s on korrektne avaldis }
function korras(s : string) : boolean;
var i : integer;
begin
   s := s + ' ';                            { lisame avaldisele lputunnuse }
   i := 1;
   if loe_avaldis(s, i) then begin           { kui rida algas avaldisega... }
      korras := (i = length(s));       { ... ja "le" ji ainult lputunnus }
   end else begin
      korras := false;                          { ... muidu oli midagi viga }
   end;
end;

var
   fsis, fval : text;                              { sisend- ja vljundfail }
   n, i : integer;                                { avaldiste arv, loendaja }
   s : string;                                            { jooksev avaldis }

begin
   assign(fsis, sisf); reset(fsis);          { avame sisendfaili lugemiseks }
   assign(fval, valf); rewrite(fval);    { avame vljundfaili kirjutamiseks }
   
   readln(fsis, n);                                  { loeme avaldiste arvu }
   writeln(fval, n);                              { kirjutame vastuste arvu }
   for i := 1 to n do begin                  { ttleme avaldised kshaaval }
      readln(fsis, s);                                     { loeme avaldise }
      if korras(s) then begin                     { kontrollime korrektsust }
         writeln(fval, 'JAH');                         { vljastame vastuse }
      end else begin
         writeln(fval, 'EI');                          { vljastame vastuse }
      end;
   end;                                          { vtame jrgmise avaldise }

   close(fsis);                                       { sulgeme sisendfaili }
   close(fval);                                      { sulgeme vljundfaili }
end.
