{ kontroll.pas                                                              }
{ 2002-11-09 programmeerimisvistluse edasijudnute 3. lesande tester      }
{    REIS MBER SAARE                                                       }
{ Ahto Truu                                                                 }


{ NB! Tegeliku teepikkuse kontroll ttab ainult vrdlemisi mistlike       }
{ kaartidega. Enne protestide esitamist vaadake kaart oma silmaga le.      }


{$I+}

const
   maxr = 100;
   maxv = 100;

type
   kaart = record
      r, v : integer;
      a : array [1..maxr, 1..maxv] of char;
   end;

var
   f : text;                                           { sisend/vljundfail }
   k : kaart;                                               { kaardi andmed }
   d1 : integer;                                { nidislahenduse teepikkus }
   d2 : integer;                             { lahenduse videtav teepikkus }
   d3 : integer;                              { lahenduse tegelik teepikkus }
   i, j : integer;
   s : string;
   t : boolean;
   ii, jj, u, uu : integer;
   u12, u21, u3 : integer;

begin
   if paramcount <> 3 then begin
      writeln('Sntaks on: ', paramstr(0), ' sisendfail nidisfail vljundfail');
      halt(1);
   end;

   { loeme sisendandmed }
   assign(f, paramstr(1)); reset(f);
   readln(f, k.r, k.v);
   for i := 1 to k.r do begin
      for j := 1 to k.v do
         read(f, k.a[i, j]);
      readln(f);
   end;
   close(f);

   { loeme ige teepikkuse }
   assign(f, paramstr(2)); reset(f);
   readln(f, d1);
   close(f);

   { loeme vljundandmed }
   assign(f, paramstr(3)); reset(f);
   readln(f, d2);
   if d2 <> d1 then begin
      writeln('Vale pikkus ', d2, ', peaks olema ', d1);
   end else begin
      writeln('Pikkus OK');
   end;
   for i := 1 to k.r do begin
      readln(f, s);
      if length(s) <> k.v then begin
         writeln('Kaart rikutud: lubamatu reapikkus ', length(s));
         halt(1);
      end;
      for j := 1 to k.v do begin
         if k.a[i, j] = '.' then
            t := (s[j] in ['.', '+'])
         else
            t := (s[j] = k.a[i, j]);
         if not t then begin
            writeln('Kaart rikutud: lubamatu smbol kohal ', i, ' ', j);
            halt(1);
         end;
         k.a[i, j] := s[j];
      end;
   end;
   if not eof(f) then begin
      writeln('Kaart rikutud: liigsed read vljundfailis');
      halt(1);
   end;
   writeln('Kaart OK');
   close(f);

   { kontrollime tee olemasolu }
   t := false;
   for i := 1 to k.r do
      for j := 1 to k.v do
         if k.a[i, j] = '+' then
            t := true;
   if not t then begin
      writeln('Tee mrkimata');
      halt(0);
   end;

   { leiame tegeliku teepikkuse }
   u12 := 0; u21 := 0; u3 := 0;
   d3 := 0; u := 1;
   repeat
      for i := 1 to k.r do
         for j := 1 to k.v do
           if k.a[i, j] = '*' then
              for ii := i - 1 to i + 1 do
                 for jj := j - 1 to j + 1 do
                    if not((ii < 1) or (ii > k.r) or
                           (jj < 1) or (jj > k.v)) then
                       if k.a[ii, jj] = '+' then
                          k.a[ii, jj] := '-';
      uu := u; u := 0;
      for i := 1 to k.r do
         for j := 1 to k.v do
            if k.a[i, j] = '-' then begin
               k.a[i, j] := '*';
               u := u + 1;
            end else if k.a[i, j] = '*' then
               k.a[i, j] := '@';
      if u > 2 then u3 := u3 + 1;
      if (uu = 1) and (u = 2) then u12 := u12 + 1;
      if (uu = 2) and (u = 1) then u21 := u21 + 1;
      d3 := d3 + 1;
   until u = 0;
   d3 := 2 * d3 + uu - 3;
   for i := 1 to k.r do
      for j := 1 to k.v do
         if k.a[i, j] = '+' then
            u := u + 1;
   if (u > 0) or (u3 > 0) then begin
      writeln('Tee vigane');
      halt(1);
   end;
   if (u12 <> 1) or (u21 > 1) then begin
      writeln('Tee arvatavasti vigane');
      writeln('Tee pikkus ', d3, '?');
   end else begin
      writeln('Tee arvatavasti OK');
      if d3 = d1 then begin
         writeln('Tee pikkus arvatavasti OK');
      end else begin
         writeln('Tee pikkus ', d3, ', peaks olema ', d1);
      end;
   end;
end.
