{ 021109a3b.pas                                                             }
{ 2002-11-09 programmeerimisvistluse algajate 3. lesande lahendus         }
{    AVALDIS                                                                }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'AVALDIS.SIS';
   valf = 'AVALDIS.VAL';
   num = ['0'..'9'];
   teh = ['+', '-', '*', '/'];

{ "loeb" snest s alates positsioonist i he mrgita tisarvu }
function loe_arv(var s : string; var i : integer) : boolean;
begin
   loe_arv := (s[i] in num);         { arvus peab olema vhemalt ks number }
   { kik jrgnevad numbrid on ka samas arvus }
   while s[i] in num do begin
      i := i + 1;
   end;
end;

{ "loeb" snest s alates positsioonist i he avaldise }
function loe_avaldis(var s : string; var i : integer) : boolean;
begin
   if s[i] in num then begin       
      loe_avaldis := loe_arv(s, i);    { kui algab numbriga, peab olema arv }
   end else begin                                   { muidu peavad olema... }
      loe_avaldis := false;
      if s[i] = '(' then begin                        { ... algav sulg, ... }
         i := i + 1;
         if loe_avaldis(s, i) then begin                 { ... avaldis, ... }
            if s[i] in teh then begin                  { ... tehtemrk, ... }
               i := i + 1;
               if loe_avaldis(s, i) then begin           { ... avaldis, ... }
                  if s[i] = ')' then begin            { ... ja lpetav sulg }
                     i := i + 1;
                     loe_avaldis := true;                  { siis on korras }
                  end;
               end;
            end;
         end;
      end;
   end;
end;

{ kontrollib, kas snes s on korrektne avaldis }
function korras(s : string) : boolean;
var i : integer;
begin
   s := s + ' ';                            { lisame avaldisele lputunnuse }
   i := 1;
   if loe_avaldis(s, i) then begin           { kui rida algas avaldisega... }
      korras := (i = length(s));       { ... ja "le" ji ainult lputunnus }
   end else begin
      korras := false;                          { ... muidu oli midagi viga }
   end;
end;

var
   fsis, fval : text;                              { sisend- ja vljundfail }
   n, i : integer;                                { avaldiste arv, loendaja }
   s : string;                                            { jooksev avaldis }

begin
   assign(fsis, sisf); reset(fsis);          { avame sisendfaili lugemiseks }
   assign(fval, valf); rewrite(fval);    { avame vljundfaili kirjutamiseks }
   
   readln(fsis, n);                                  { loeme avaldiste arvu }
   writeln(fval, n);                              { kirjutame vastuste arvu }
   for i := 1 to n do begin                  { ttleme avaldised kshaaval }
      readln(fsis, s);                                     { loeme avaldise }
      if korras(s) then begin                     { kontrollime korrektsust }
         writeln(fval, 'JAH');                         { vljastame vastuse }
      end else begin
         writeln(fval, 'EI');                          { vljastame vastuse }
      end;
   end;                                          { vtame jrgmise avaldise }

   close(fsis);                                       { sulgeme sisendfaili }
   close(fval);                                      { sulgeme vljundfaili }
end.
