{ 021109e1.pas                                                              }
{ 2002-11-09 programmeerimisvistluse edasijudnute 1. lesande lahendus    }
{    TRIPS-TRAPS-TRULL                                                      }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'TTT.SIS';
   valf = 'TTT.VAL';
   max = 3;

type
   laud = array [1..max, 1..max] of char;

{ loeb failist seisu }
procedure loe (var f : text; var l : laud);
var i, j : integer;
begin
   for i := 1 to max do begin
      for j := 1 to max do
         read(f, l[i, j]);
      readln(f);
   end;
end;

{ loendab mrgi esinemised laual }
function marke (var l : laud; c : char) : integer;
var i, j, k : integer;
begin
   k := 0;
   for i := 1 to max do
      for j := 1 to max do
         if l[i, j] = c then
            k := k + 1;
   marke := k;
end;

{ loendab mrgiga tidetud read/veerud/diagonaalid laual }
function voite (var l : laud; c : char) : integer;
var i, j, k, kk : integer;
begin
   kk := 0;
   { read }
   for i := 1 to max do begin
      k := 0;
      for j := 1 to max do
         if l[i, j] = c then
            k := k + 1;
      if k = max then
         kk := kk + 1;
   end;
   { veerud }
   for i := 1 to max do begin
      k := 0;
      for j := 1 to max do
         if l[j, i] = c then
            k := k + 1;
      if k = max then
         kk := kk + 1;
   end;
   { peadiagonaal }
   k := 0;
   for i := 1 to max do
      if l[i, i] = c then
         k := k + 1;
   if k = max then
      kk := kk + 1;
   { krvaldiagonaal }
   k := 0;
   for i := 1 to max do
      if l[i, max - i + 1] = c then
         k := k + 1;
   if k = max then
      kk := kk + 1;
   voite := kk;
end;

var
   f : text;
   l : laud;
   mX, m0 : integer;                            { kummagi mrkide arv laual }
   vX, v0 : integer;                            { kummagi vitude arv laual }

begin
   assign(f, sisf); reset(f);
   loe(f, l);
   close(f);

   mX := marke(l, 'X'); m0 := marke(l, '0');
   vX := voite(l, 'X'); v0 := voite(l, '0');

   assign(f, valf); rewrite(f);
   if mX < m0 then
      writeln(f, 'VIGA')                      { 0 kinud mitu korda jrjest }
   else if mX > m0 + 1 then 
      writeln(f, 'VIGA')                      { X kinud mitu korda jrjest }
   else if vX > 0 then
      if mX = m0 then
         writeln(f, 'VIGA')                       { 0 kinud prast X vitu }
      else
         writeln(f, 'X VOIT')
   else if v0 > 0 then
      if mX > m0 then
         writeln(f, 'VIGA')                       { X kinud prast 0 vitu }
      else
         writeln(f, '0 VOIT')
   else if mX + m0 = max * max then
      writeln(f, 'VIIK')
   else if mX = m0 then
      writeln(f, 'X KAIK')
   else
      writeln(f, '0 KAIK');
   close(f);
end.
